<?php
/******************************************
* - a generic form, optional part of a simple securitization package
* - provides simple "captcha like" human verification, and optionally an authentication login
* - required by v_required.php if NOT already verified AND use_v_form = true
* - has access to vars from requirer, v_require, and $_SESSION
* - dynamic input borders dependent on access to jquery
******************************************/

?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en">
<head>
  <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
  <script type="text/javascript">
  function initialize ()
  {
      if (!document.all) document.forms[0].elements[1].focus();		// big hack, required for IE dynamic borders
  }
  </script>

  <!-- for IE dynamic input borders --><!--[if LTE IE 7]>
  <script type="text/javascript" src="<?php echo $js_dir ?>/jquery.js"></script>
  <script type="text/javascript">

  $(document).ready(function(){

    $(":text,:password,textarea").bind("focus", function(e){
      $(this).addClass("border_focus");
    });

    $(":text,:password,textarea").bind("blur", function(e){
      $(this).removeClass("border_focus");
    });

    document.forms[0].elements[1].focus();

  });

  </script>
  <![endif]-->

  <style type="text/css" media="all">

	#verify_code { background: url('<?php echo $v_dir ?>/v_image.php?<?php echo SID ?>') white 50% 0% no-repeat; }
    #brand,#brand a,#brand a:visited { color: #ccc; font-size: x-small; font-family: arial, verdana, helvetica, sans-serif; text-align: center; }

	.success { background: #CCFF99; border-color: #99FF00; }
	.warning { background: #FFFF99; border-color: #FFFF00; }

	.success,
	.warning
	{
		border-style: solid;
		border-width: 3px;
		color: black;
		font-size: .8em;
		font-weight: bolder;
		margin-right: 1em;
		padding: 2px;
	}

	/* ----------- Dynamic Input Borders ------------- 
	- to make these universal, set input margins and padding elsewhere
	- using blur class because attrib selectors break jquery for IE which provides :focus functionality
	- to prevent dancing inputs on focus, set blur borders the same width as focus borders */

	.border_blur, .border_focus, textarea, textarea:focus, input[type=text]:focus, input[type=password]:focus
	{
		border-style: solid;
		border-width: 2px;
	}

	.border_blur
	{
		border-color: black;
	}

	.border_focus
	{
			border-color: #975A6F;
	}

	.two-column .border_blur, .two-column textarea
	{
		border-color: #aaa;
	}

	.two-column .border_focus, .two-column input[type=text]:focus, .two-column input[type=password]:focus, .two-column textarea:focus
	{
			border-color: #73233E;
	}

	/* ----------- Dynamic Input Borders -------------*/

	.two-column label
	{
		float: left;		/* block float the labels to left column, set a width */
		margin: 5px 0 0;	/* set top margin same as form input - textarea etc. elements */
		padding: 0;
		text-align: right;
		width: 8em;
	}

	.two-column input,
	.two-column textarea
	{
		display:inline-block;	/* display: inline; must not be set or will hide submit buttons in IE 5x mac */
				/*width:auto; set width of form elements to auto-size, otherwise watch for wrap on resize */
		margin:5px 0 0 10px;	/* set margin on left of form elements rather than right of
									label aligns textarea better in IE */
	}

	.two-column textarea { overflow: auto; }

	.two-column input#reset
	{
		margin-left: 0px; /* set margin-left back to zero on reset button (set above) */
	}

	.two-column small
	{
		display: block;
		margin: 0 0 .5em 10.5em;	/* instructions/comments left margin set to align w/ right column inputs */
	}
  </style>

  <title>Humanity Verification</title>
</head>

<body>

<!-- name attribute not allowed in xhtml strict -->
<form id="f" class="two-column" action="<?php echo $_SERVER['PHP_SELF'] ?>" method="post">

<?php
if ($form_msg) echo "<p class='warning'> $form_msg </p>";

echo "<fieldset>";

if ($login_required)
{
?>
    <legend>Login Credentials Required</legend>
      <label for="username" accesskey="u">Username:admin</label>
        <input type="text" id="username" name="username" class="border_blur" 
         value="<?php if (isset($_POST['username'])) echo ($_POST['username']) ?>" /><br />
      <label for="password" accesskey="p">Password:4magic</label>
        <input type="password" id="password" name="password" class="border_blur" 
         value="<?php if (isset($_POST['password'])) echo ($_POST['password']) ?>" />
  </fieldset>
  <fieldset>
<?php
}
?>
    <legend>Please Verify Your Humanity</legend>
      <label for="verify_code" accesskey="e">Enter code:</label>
        <input type="text" id="verify_code" name="verify_code" class="border_blur" /><br />
        <small>(<?php echo $vCodeLen ?> letters and/or numbers)</small>

      <label for="kludge"></label>
        <input type="submit" class="submit" value="Continue" />
        <input type="hidden" name="secret" value="<?php echo $_SESSION['secret'] ?>" />
        <input type="hidden" name="<?php echo session_name() ?>" value="<?php echo session_id() ?>" />
  </fieldset>
</form>

      <p id="brand">Security by <a href="/">Us</a> | 
      validate <a href="http://validator.w3.org/check?uri=referer">xhtml</a>, <a href="http://jigsaw.w3.org/css-validator/check/referer">css</a>
      </p>

<?php
if ($debug)
{
  ShowPHPvars($_COOKIE,$_POST,$_SESSION);  //,$_SERVER
}
?>

<script type="text/javascript"><!-- 
  initialize();
//--></script>
</body>
</html>
