<?php
/**********************************************************************
*  This outputs a captcha image and sets $_SESSION['time_start'] and $_SESSION['v_code_hash']
*  Cookie Independent, but must process GET request (css URL) to access the current session
*  No security risk if this is called directly
*  Implement this image 1 of 2 ways:
*  - local <style> #yourinputID { background: url('img/v_image.php?<?php echo SID ?>') white 50% 0% no-repeat; }
	(cookie independent, uses a non-sharable URL to maintain the session)
*  - or directly in markup as <img src="v_image.php" alt="" title="" />
*  Related:
*  - see v_require.php for further instructions
**********************************************************************/
if ( !function_exists("gd_info") ) die ("Graphics support not found, enable the GD extension in php.ini");

ini_set('session.use_cookies', 0);
session_name(strtolower(session_name())); // for strict xhtml 1, use existing session_name in lower case
session_start();


// A CHANCE TO OVER-RIDE SOME IMAGE DEFAULTS (and so we can call this directly to debug)
$vCodeLen	= isset($_SESSION['vCodeLen']) ? $_SESSION['vCodeLen'] : 3;
$v_img_width	= isset($_SESSION['v_img_width']) ? $_SESSION['v_img_width'] : 100;
$v_img_height	= isset($_SESSION['v_img_height']) ? $_SESSION['v_img_height'] : 19;
$v_img_color_bg	= isset($_SESSION['v_img_color_bg']) ? $_SESSION['v_img_color_bg'] : "fff";
$v_img_color_txt = isset($_SESSION['v_img_color_txt']) ? $_SESSION['v_img_color_txt'] : "888";


// OK, let's get started with this captcha
$alphanum = "abcdefghijkmnopqrstuvwxyz0123456789";		// L removed
$v_img_txt = substr(str_shuffle($alphanum), 0, $vCodeLen);
$_SESSION['v_code_hash'] = md5($v_img_txt);			// hash this so not visible in session file

// Create start of reply timelimit on each page load
$_SESSION['time_start'] = $_SERVER['REQUEST_TIME'];

// Convert hex color codes to R, G, B string
function hex_to_rgb($h) {

	if (strpos($h, '#') === 0) { 
		$h = substr($h, 1);
	}
	$arrRGB = array();
	if (strlen($h) == 6) {
		$arrRGB[] = (int)hexdec(substr($h, 0, 2));
		$arrRGB[] = (int)hexdec(substr($h, 2, 2));
		$arrRGB[] = (int)hexdec(substr($h, 4, 2));
	} else if (strlen($h) == 3) {
		$arrRGB[] = (int)hexdec(substr($h, 0, 1) . substr($h, 0, 1));
		$arrRGB[] = (int)hexdec(substr($h, 1, 1) . substr($h, 1, 1));
		$arrRGB[] = (int)hexdec(substr($h, 2, 1) . substr($h, 2, 1));
	}
	return $arrRGB;
}

// create the image
$image = imagecreate($v_img_width, $v_img_height);

// set the background color
list($rr, $gg, $bb) = hex_to_rgb($v_img_color_bg);
imagecolorallocate ($image, $rr, $gg, $bb);

// set the text color
list($rr, $gg, $bb) = hex_to_rgb($v_img_color_txt);
$v_img_color_txt = imagecolorallocate ($image, $rr, $gg, $bb);

// add the verification code to the image, and remove it from $_SESSION
imagestring ($image, 5, 35, 1, $v_img_txt, $v_img_color_txt);

// dwb, add a line through, adds a little ocr difficulty
//imageline($image, $x1, $y1, $x2, $y2, $color);

// send several headers to make sure the image is not cached 
// taken directly from the PHP Manual
header("Expires: Mon, 26 Jul 1997 05:00:00 GMT");	// Date in the past
header("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT");	// always modified
// HTTP/1.1 - lower case suggested fix for FF caching (not related to the image caching issue)
header("cache-control: no-store,no-cache,must-revalidate,max-age=-1");
header("cache-control: post-check=0,pre-check=0", false);
header("pragma: no-store,no-cache");	// HTTP/1.0

// send the content type header so the image is displayed properly
header('Content-type: image/jpeg');

// send the image to the browser
imagejpeg($image);

// destroy the image to free up the memory
imagedestroy($image);

?>