<?php
/******************************************
* - part of a simple securitization package
* - this is required by the requirer page, the page that needs access limited
* - optional over-rides, add these vars in the requirer to over-ride defaults set below:
	$login_required = FALSE;		// can be set in the requirer if this script called from more than one other page
	$form_needed	= FALSE;		// defaults to TRUE
* - minimum req'd, set and add these lines in the requirer above your doctype declaration:
	$v_dir = "img";					// relative path from this to the v_file's folder (without trailing "/")
	require_once($v_dir."/v_require.php");	// below the $v_dir var but early in a requirer page needing verification
* - has access to vars from requirer, v_require, and $_SESSION
******************************************/

//*********** start user vars ************
$debug		= FALSE;
$js_dir		= "/img";	// absolute path from docroot to javascript (jquery) for <IE7 dynamic input borders
$v_username	= "admin";	// set this if login required (case-sensitive)
$v_password	= "4magic";	// set this if login required (case-sensitive)
//*********** end user vars *************

ini_set('session.use_cookies', 0);

if ($debug)
{
  ini_set('display_errors', 1);
  error_reporting(E_ALL | E_STRICT);
}
else
{
  ini_set('display_errors', 0);
  ini_set('log_errors','1');
  //ini_set('error_log',_ERR_LOG_);	// should be set in php.ini
  //error_reporting(E_ALL ^ E_NOTICE);	// should be set in php.ini
}

// holds user messages from this script, but use this in the form to display messages to the user
$form_msg	= "";


if (session_id() === "")			// in case the requirer has already started a session
{
  session_name(strtolower(session_name()));	// for strict xhtml 1, use existing session_name in lower case
  session_start();
}


// INCORPORATE CAPTCHA IMAGE OVER-RIDES FROM REQUIRER, used by v_image (only accepts $_GET['phpsessid'])

if ( isset($v_img_width) )	$_SESSION['v_img_width'] = $v_img_width;
if ( isset($v_img_height) )	$_SESSION['v_img_height'] = $v_img_height;
if ( isset($v_img_color_bg) )	$_SESSION['v_img_color_bg'] = $v_img_color_bg;
if ( isset($v_img_color_txt) )	$_SESSION['v_img_color_txt'] = $v_img_color_txt;


// DEFAULTS FOR THIS VERIFICATION SCRIPT, OVER-RIDE THESE IN REQUIRER

// default length of the code the user must type, also over-rides v_image
$vCodeLen = $_SESSION['vCodeLen'] = isset($vCodeLen) ? $vCodeLen : 3;

// default time limit in seconds to submit the verification form
$timeLimit = isset($timeLimit) ? $timeLimit : 60;

// default uses our form, override in requirer if using your form
$form_needed = isset($form_needed) ? $form_needed : TRUE;

// default uses password authentication, override in requirer if not needed or using your own
$login_required = isset($login_required) ? $login_required : TRUE;


// LOGOUT REQUEST VIA URL, ?will not work with use_only_cookies?
if (isset($_GET['action']) && $_GET['action'] === "logout")
{
  unset($_SESSION['verified']);
  if ( isset($_COOKIE[session_name()]) ) setcookie(session_name(), '', time()-42000, '/');
  header("Location: ".$_SERVER["PHP_SELF"]);
  exit;
}


function spew($arg)
{
  echo "\n<ul style='list-style-type:none'>\n";
  foreach ($arg as $k => $v)
  {
    echo "<li>";
    if (is_array($v)) spew($v);
    else echo "$k = $v";
    echo "</li>\n";
  }
  echo "</ul>";
}


function ShowPHPvars ($args)
{
   $numargs = func_num_args();
   $arg_list = func_get_args();

   //echo "<p>Number of top level \$GLOBALS present - ".count($GLOBALS)."</p>";
   //echo "<p>\$args type is: ".gettype($args)." and \$numargs is: $numargs</p>";

   for ($i = 0; $i < $numargs; $i++)
   {
      echo "<p>";
      $arg = ($arg_list[$i]);
      //$arg = (array) eval('\$_POST');
      //echo "<p>\$arg type is: ".gettype($arg)." and spewing</p>";
      spew ($arg);
      echo "</p>";
   }
}

function verify ()
{
  global $form_msg, $vCodeLen, $timeLimit, $login_required, $v_username, $v_password, $debug;

  // FORM SHARED SECRET, validate 32 byte hexdecimal MD5 secret
  if (!isset($_SESSION['secret']) || strlen($_POST['secret']) !== 32 || !ctype_xdigit($_POST['secret']) 
  	|| $_POST['secret'] !== $_SESSION['secret'] )
  {
    $form_msg .= ' Form mismatched. Please try again.';
    return false;
  }

  // TIME LIMIT
  if ( !isset($_SESSION['time_start']) || $_SERVER['REQUEST_TIME'] - $_SESSION['time_start'] > $timeLimit)
  {
    $form_msg .= ' Form has expired. Please try again.';
    return false;
  }

  // LOGIN HERE
  if ($login_required)
  {
    if (!isset($_POST['username']) || $v_username !== $_POST['username']
     || !isset($_POST['password']) || $v_password !== $_POST['password'])
    {
      $form_msg .= ' Username or password incorrect. Please try again.';
      return false;
    }
  }

  // VERIFICATION CODE
  if (!$debug)
  {
    if ( !isset($_POST['verify_code']) || strlen($_POST['verify_code']) !== $vCodeLen 
    	|| !ctype_alnum($_POST['verify_code']) 
    	|| md5(strtolower($_POST['verify_code'])) !== $_SESSION['v_code_hash'] )
    {
      $form_msg .= ' Verification code mismatch. Please try again.';
      return false;
    }
  }
  else
  {
    if ( !isset($_POST['verify_code'])){
      $form_msg .= ' Verification code not set.';
      return false;
    }
    if ( strlen($_POST['verify_code']) !== $vCodeLen ){
      $form_msg .= " strlen not equal $vCodeLen.";
      return false;
    }
    if ( !ctype_alnum($_POST['verify_code']) ){
      $form_msg .= ' ctype not alpha-numberic.';
      return false;
    }
    if ( md5(strtolower($_POST['verify_code'])) !== $_SESSION['v_code_hash'] )
    {
      $form_msg .= ' Verification code mismatch. Please try again.';
      return false;
    }
  }

  $_SESSION['v_code_hash'] = '';
  return true;

}


// VERIFICATION NEEDED AND POST ATTEMPTED
if ( !isset($_SESSION['verified']) && isset($_POST['secret']) )
{
    if (verify()) $_SESSION['verified'] = TRUE;
}


if ( !isset($_SESSION['verified']) )
{
  // for FireFox non-localhost image caching of v_image, we need to create a new session id each visit
  session_regenerate_id();		// keeps existing $_SESSION array

  // Generate the form secret each page request until verified, used by user's form or the default
  $_SESSION['secret'] = md5(uniqid(rand(), true));

  if ($form_needed)			// stop here if we need to display a form
  {
    require_once "v_form.php";
    exit;
  }
}
?>